require "ESBI/version"

module ESBI
  class Error < StandardError; end

  ## Learning Model
  class Naive_Bayes

    def self.baysian_seed
      old_greeting  = File.read("data/baysian/archive/greeting_archive.txt")
      old_agent     = File.read("data/baysian/archive/agent_archive.txt")
      old_request   = File.read("data/baysian/archive/request_archive.txt")
      old_gender    = File.read("data/baysian/archive/gender_archive.txt")
      old_object    = File.read("data/baysian/archive/object_archive.txt")
      old_for_from  = File.read("data/baysian/archive/for_from_archive.txt")
      old_direction = File.read("data/baysian/archive/direction_archive.txt")

      print  "Train greeting evaluator on >> "; greeting  = gets.chomp
      print     "Train agent on evaluator >> "; agent     = gets.chomp
      print   "Train request evaluator on >> "; request   = gets.chomp
      print    "Train gender evaluator on >> "; gender    = gets.chomp
      print    "Train object evaluator on >> "; object    = gets.chomp
      print  "Train for_from evaluator on >> "; for_from  = gets.chomp
      print "Train direction evaluator on >> "; direction = gets.chomp

      create_regimen = "def greeting_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:greeting,
                     :farewell)

  a.db_filepath = 'data/baysian/greeting.nb'

  #{old_greeting}
  #{greeting}

  a.save
end

def agent_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:inheritor,
                     :notinheritor)

  a.db_filepath = 'data/baysian/agent.nb'

  #{old_agent}
  #{agent}

  a.save
end

def request_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:request,
                     :demand)

  a.db_filepath = 'data/baysian/request.nb'

  #{old_request}
  #{request}

  a.save
end

def gender_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:masculine,
                     :feminine,
                     :neuter)

  a.db_filepath = 'data/baysian/gender.nb'

  #{old_gender}
  #{gender}

  a.save
end

def object_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:object,
                     :abstract)

  a.db_filepath = 'data/baysian/object.nb'

  #{old_object}
  #{object}

  a.save
end

def for_from_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:for,
                     :from)

  a.db_filepath = 'data/baysian/for_from.nb'

  #{old_for_from}
  #{for_from}

  a.save
end

def direction_trainer
  require 'naive_bayes'

  a = NaiveBayes.new(:standard,
                     :nonstandard)

  a.db_filepath = 'data/baysian/directions.nb'

  #{old_direction}
  #{direction}

  a.save
end

greeting_trainer
agent_trainer
request_trainer
gender_trainer
object_trainer
for_from_trainer
direction_trainer
"

      open("script.rb", "w") { |f|
        f.puts create_regimen
      }

      open("data/baysian/archive/greeting_archive.txt", "w") { |f|
        f.puts "  #{old_greeting}"
        f.puts "  #{greeting}"
      }

      open("data/baysian/archive/agent_archive.txt", "w") { |f|
        f.puts "  #{old_agent}"
        f.puts "  #{agent}"
      }

      open("data/baysian/archive/request_archive.txt", "w") { |f|
        f.puts "  #{old_request}"
        f.puts "  #{request}"
      }

      open("data/baysian/archive/gender_archive.txt", "w") { |f|
        f.puts "  #{old_gender}"
        f.puts "  #{gender}"
      }

      open("data/baysian/archive/object_archive.txt", "w") { |f|
        f.puts "  #{old_object}"
        f.puts "  #{object}"
      }

      open("data/baysian/archive/for_from_archive.txt", "w") { |f|
        f.puts "  #{old_for_from}"
        f.puts "  #{for_from}"
      }

      open("data/baysian/archive/direction_archive.txt", "w") { |f|
        f.puts "  #{old_direction}"
        f.puts "  #{direction}"
      }

      system("ruby script.rb")
    end

    def self.evaluate
      def self.greeting
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/greeting.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.agent
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/agent.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.request
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/request.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.gender
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/gender.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.object
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/object.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.for_from
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/for_from.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
      end

      def self.direction
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/direction.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        classification = a.classify(*b)

        print classification[0]
        puts "."
      end

      ESBI::Naive_Bayes.evaluate.greeting
      ESBI::Naive_Bayes.evaluate.agent
      ESBI::Naive_Bayes.evaluate.request
      ESBI::Naive_Bayes.evaluate.gender
      ESBI::Naive_Bayes.evaluate.object
      ESBI::Naive_Bayes.evaluate.for_from
      ESBI::Naive_Bayes.evaluate.direction
    end

  end

  ## Visual Cues
  class Eyes
    def self.camera
      system("cd images; streamer -f jpeg -o image.jpeg")
    end
  end

  ## Dynamic Decision Tree
  class Dynamic

    def self.dTree
      require "dynamicTree"

      number = File.read("data/number/input.txt").strip.to_i

      DynamicTree::Sprout.initialize_tree

      print "Move forward? (Y/N) >> "; yn = gets.chomp

      if    yn ==   "Y"; open("data/number/input.txt", "w") { |f| f.puts number = number + 1 }
      elsif yn ==   "y"; open("data/number/input.txt", "w") { |f| f.puts number = number + 1 }
      elsif yn ==   "N"; puts "Leaving input as is."
      elsif yn ==   "n"; puts "Leaving input as is."
      elsif yn == "Yes"; open("data/number/input.txt", "w") { |f| f.puts number = number + 1 }
      elsif yn == "yes"; open("data/number/input.txt", "w") { |f| f.puts number = number + 1 }
      elsif yn ==  "No"; puts "Leaving input as is."
      elsif yn ==  "no"; puts "Leaving input as is."
      end
    end

  end
  
  ## Symbolic Representation Of Shapes
  class Symbolic

    def self.line
      require "rules_ai"

      RulesAi::Rules_Set.line
    end

    def self.square
      require "rules_ai"

      RulesAi::Rules_Set.square
    end

    def self.cube
      require "rules_ai"

      RulesAi::Rules_Set.cube
    end

    def self.hyper
      require "rules_ai"

      RulesAi::Rules_Set.hyper
    end

  end

  class Creativity

    def self.write_poetry
      require "rules_ai"

      RulesAi::Rules_Set.write_poetry
    end

    def self.write_poetry
      require "rules_ai"

      RulesAi::Rules_Set.write_renpy_script
    end

  end

  ## Evolutionary Algorithm
  class Evolutionary
    def self.reset_evo
      # Gets the bot shape.
      bot_shape = File.readlines("evo_data/bot_shape/wings.txt")

      # Create a new input vector based on bot data size.
      bot_input = bot_shape.size.to_i

      # Reset user input to zero.
      reset_usr_input = 0

      open("evo_data/number/input.txt", "w") { |f|
        f.puts reset_usr_input
      }

      # Get random bot_input from bot reset.
      bot_reset = rand(bot_input)

      open("evo_data/bot_input/input.txt", "w") { |f|
        f.puts bot_reset
      }
    end

    def self.use_form
      model_type = File.read("evo_data/model/model_type.txt").strip

      puts 'Form status: Suitable...'

      sleep(3)

      number           = File.read("evo_data/number/input.txt").strip.to_i
      usr_wings        = File.readlines("evo_data/usr_shape/wings.txt")
      current_wingset  = usr_wings[number].strip

      puts "\nModel Type: #{model_type}\nAction: #{current_wingset}\n"

      sleep(3)

      # system("ruby #{current_wingset}.rb")

      if    current_wingset == "write_poetry"; ESBI::Creativity.write_poetry
      elsif current_wingset ==         "line"; ESBI::Symbolic.line
      elsif current_wingset ==       "square"; ESBI::Symbolic.square
      elsif current_wingset ==         "cube"; ESBI::Symbolic.cube
      elsif current_wingset ==        "hyper"; ESBI::Symbolic.hyper
      elsif current_wingset ==        "dTree"; ESBI::Dynamic.dTree
      elsif current_wingset ==         "eyes"; ESBI::Eyes.camera
      elsif current_wingset ==     "evaluate"; ESBI::Naive_Bayes.evaluate
      end

      reset_evo

      abort
    end

    def self.reshape
      system("clear")

      model_type = File.read("evo_data/model/model_type.txt").strip

      bot_choice = File.read("evo_data/bot_input/input.txt").strip.to_i
      number     = File.read("evo_data/number/input.txt").strip.to_i

      usr_wings = File.readlines("evo_data/usr_shape/wings.txt")
      bot_wings = File.readlines("evo_data/bot_shape/wings.txt")

      current_wingset  = usr_wings[number]
      current_botwings = bot_wings[bot_choice]

      puts "The user #{model_type} model is: #{current_wingset}"

      puts "The bot #{model_type} model is: #{current_botwings}"

      if current_wingset == current_botwings
        use_form
      else
        puts "Form status: Changing form..."

        sleep(3)

        new_value = number + 1

        open("evo_data/number/input.txt", "w") { |f|
          f.puts new_value
        }
      end

      ESBI::Evolutionary.reshape
    end
  end

  # Smart Translation
  class Translate

    def self.translate
      number = File.read("data/input/number.txt").strip.to_i
      input  = File.readlines("data/input/input.txt")

      active_input = input[number].downcase.split(" ")

      translate = {
        'ruh'                             =>     "the-masculine",
        'rah'                             =>      "the-feminine",
        'roh'                             =>        "the-neuter",
        'yona'                            =>                 "a",
        'yonei'                           =>                "an",
        'yonas'                           =>          "a-neuter",
        'eneru'                           =>             "black",
        'berena'                          =>             "white",
        'erudi'                           =>               "red",
        'eviyette'                        =>            "purple",
        'beru'                            =>               "red",
        'evene'                           =>             "green",
        'yeru'                            =>            "yellow",
        'eranige'                         =>            "orange",
        'enesu'                           =>             "North",
        'wesi'                            =>              "West",
        'easi'                            =>              "East",
        'siuha'                           =>             "South",
        'upe'                             =>                "up",
        'dio'                             =>              "down",
        'feru'                            =>           "dorward",
        'biosi'                           =>          "backward",
        'iniwa'                           =>            "inward",
        'utiwa'                           =>           "outward",
        'esakeru'                         =>          "sneakers",
        'deruesu'                         =>       "dress-shoes",
        'eheru'                           =>             "heels",
        'siabi'                           =>             "clogs",
        'siabi-biesa'                     =>      "wooden-clogs",
        'berukiesiti'                     =>      "birkenstocks",
        'esiadi'                          =>           "sandals",
        'tero'                            =>          "trousers",
        'sikeru'                          =>             "skirt",
        'deresi'                          =>             "dress",
        'sehiere'                         =>             "shirt",
        'sioki'                           =>          "stocking",
        'sitaka'                          =>             "socks",
        'sitaki'                          =>             "steak",
        'siho-sitaki'                     =>        "chop-steak",
        'befi'                            =>              "beef",
        'shikini'                         =>           "chicken",
        'tieru'                           =>            "turkey",
        'liam'                            =>              "lamb",
        'ehaki'                           =>               "elk",
        'deru'                            =>              "deer",
        'pirosi'                          =>              "porc",
        'bieru'                           =>              "bear",
        'siaro'                           =>            "carrot",
        'pitat'                           =>            "potato",
        'siaba'                           =>           "cabbage",
        'sipinas'                         =>           "spinach",
        'eretuce'                         =>           "lettuce",
        'siwa-pitat'                      =>      "sweet-potato",
        'ginie'                           =>            "ginger",
        'siquasi'                         =>            "squash",
        'piemaki'                         =>           "pumpkin",
        'tea'                             =>               "tea",
        'siofee'                          =>            "coffee",
        'eribos'                          =>             "herbs",
        'givimio'                         =>           'give-me',
        'ehieru'                          =>              'hour',
        'vieruti'                         =>            'vortex',
        'perumipito'                      =>          'promptor',
        'esipier'                         =>            'cipher',
        'digisi-esitimi'                  =>   'digest estimate',
        'ehypier-sierusutio'              => 'hyper calculation',
      }

      word_01 = translate[active_input[0]]
      word_02 = translate[active_input[1]]
      word_03 = translate[active_input[2]]
      word_04 = translate[active_input[3]]
      word_05 = translate[active_input[4]]
      word_06 = translate[active_input[5]]
      word_07 = translate[active_input[6]]
      word_08 = translate[active_input[7]]
      word_09 = translate[active_input[8]]
      word_10 = translate[active_input[9]]

      translated = "Translated: #{word_01} #{word_02} #{word_03} #{word_04} #{word_05} #{word_06} #{word_07} #{word_08} #{word_09} #{word_10}"

      open("output/translator/translation.txt", "w") { |f|
        f.puts translated
      }
    end

    def self.classify
      def self.download_data
        system("cd data/baysian; w3m /home/sarah/public_sync/downloads/shared_dataset/language.nb")
      end

      def self.naive_bayes
        require "naive_bayes"

        a = NaiveBayes.load('data/baysian/language.nb') 

        # b = File.read("data/input/document.txt").split(' ')

        number = File.read("data/input/number.txt").strip.to_i
        input  = File.read("data/input/input.txt")

        b = input[number].downcase.split(" ")

        word_one = a.classify(*b[0])
        word_two = a.classify(*b[1])
        word_tre = a.classify(*b[2])
        word_fro = a.classify(*b[3])
        word_fiv = a.classify(*b[4])
        word_six = a.classify(*b[5])
        word_sev = a.classify(*b[6])

        ## Labels
        first_label  = word_one[0]
        second_label = word_two[0]
        third_label  = word_tre[0]
        fourth_label = word_fro[0]
        fifth_label  = word_fiv[0]
        sixth_label  = word_six[0]
        seven_label  = word_sev[0]

        ## Probabilities
        first_prob  = word_one[1]
        second_prob = word_two[1]
        third_prob  = word_tre[1]
        fourth_prob = word_fro[1]
        fifth_prob  = word_fiv[1]
        sixth_prob  = word_six[1]
        seven_prob  = word_sev[1]

        open("output/baysian/labels.txt", "w") { |f|
          f.puts "  Labels:\n  #{first_label}\n  #{second_label}\n  #{third_label}\n  #{fourth_label}\n  #{fifth_label}\n  #{sixth_label}\n  #{seventh_label}"
        }

        open("output/baysian/probabilities.txt", "w") { |f|
          f.puts "  Probabilities:\n  #{first_prob}\n  #{second_prob}\n  #{third_prob}\n  #{fourth_prob}\n  #{fifth_prob}\n  #{sixth_prob}\n  #{seventh_prob}"
        }

        puts "  Labels:\n  #{first_label}\n  #{second_label}\n  #{third_label}\n  #{fourth_label}\n  #{fifth_label}\n  #{sixth_label}\n  #{seventh_label}\n"
        puts "  Probabilities:\n  #{first_prob}\n  #{second_prob}\n  #{third_prob}\n  #{fourth_prob}\n  #{fifth_prob}\n  #{sixth_prob}\n  #{seventh_prob}\n\n"
      end

      def self.remove_data
        system("cd data/baysian; shred --remove language.nb")
      end

      SmartTranslator::Translate.classify.download_data
      SmartTranslator::Translate.classify.naive_bayes
      SmartTranslator::Translate.classify.remove_data
    end

    def self.rules_ai
      number  = File.read("data/input/number.txt").strip.to_i
      command = File.readlines("data/input/input.txt")

      input = command[number]

      case input

      when "Givimio ruh ehieru"
        require "rules_ai"; RulesAi::Rules_Set.hours_passed
      when "Givimio ruh vieruti"
        require "rules_ai"; RulesAi::Rules_Set.tesla_multiplication
      when "Givimio ruh perumipito"
        require "rules_ai"; RulesAi::Rules_Set.autonomous_prompting
      when "Givimio ruh esipier"
        require "rules_ai"; RulesAi::Rules_Set.mixed_13
      when "Givimio yona digisi esitimi"
        require "rules_ai"; RulesAi::Rules_Set.estimate_digest
      when "Givimio yona ehypier sierusutio"
        require "rules_ai"; RulesAi::Rules_Set.calculate_hyper
      when "Givimio yona ehini"
        require "rules_ai"; RulesAi::Rules_Set.line
      when "Givimio yona esiqieru"
        require "rules_ai"; RulesAi::Rules_Set.square
      when "Givimio yona esibu"
        require "rules_ai"; RulesAi::Rules_Set.cube
      when "Givimio yona ehypier esibu"
        require "rules_ai"; RulesAi::Rules_Set.hyper
      when "Givimio yona epieru"
        require "rules_ai"; RulesAi::Rules_Set.write_poetry
      when "Givimio yona enu eheru"
        require "rules_ai"; RulesAi::New_Routine.generate_ruleset
      else
        puts "#{bot_name}: No rule for this specific sentence."
      end
    end

    def self.down_index
      number = File.read("data/input/number.txt").to_i

      open("data/input/number.txt", "w") { |f|
        f.puts number = number + 1
      }
    end

    def self.up_index
      number = File.read("data/input/number.txt").to_i

      open("data/input/number.txt", "w") { |f|
        f.puts number = number - 1
      }
    end
  end
end
